## ros-crystal-xacro 2.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(xacro)

find_package(ament_cmake REQUIRED)

install(FILES scripts/completion.bash DESTINATION share/${PROJECT_NAME}/environment)

## The following manually installs the python package and the entry-point script
## Using ament_cmake, we cannot actually use setup.py to install these...

# install xacro python package
ament_python_install_package(xacro)
# install main script
install(PROGRAMS scripts/xacro DESTINATION bin)
install(PROGRAMS scripts/xacro DESTINATION lib/${PROJECT_NAME})

if(BUILD_TESTING)
  ## run linters as defined in package.xml
  find_package(ament_lint_auto REQUIRED)
  ament_lint_auto_find_test_dependencies()

  ## add tests for xacro's cmake functions
  add_subdirectory(test)
endif()

ament_package(
  CONFIG_EXTRAS cmake/xacro-extras.cmake
)

=== test/CMakeLists.txt ===
# Create dummy ament_index for pytest, such that $(find xacro)/test will point to the current folder
set(TEST_AMENT_INDEX "${CMAKE_CURRENT_BINARY_DIR}/test_ament_index")
file(GENERATE OUTPUT "${TEST_AMENT_INDEX}/share/ament_index/resource_index/packages/${PROJECT_NAME}" CONTENT "")
file(MAKE_DIRECTORY "${TEST_AMENT_INDEX}/share/${PROJECT_NAME}")
execute_process(COMMAND ${CMAKE_COMMAND} -E create_symlink
  "${CMAKE_CURRENT_SOURCE_DIR}" "${TEST_AMENT_INDEX}/share/${PROJECT_NAME}/test")

# Finally, run pytest
find_package(ament_cmake_pytest REQUIRED)
ament_add_pytest_test(pytest .
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
  ENV AMENT_PREFIX_PATH=${CMAKE_CURRENT_BINARY_DIR}/test_ament_index
  )

add_test(NAME xacro_cmake
  # run test-cmake.sh for subdir test-xacro-cmake
  COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test-cmake.sh ${CMAKE_CURRENT_SOURCE_DIR}/test-xacro-cmake
  )

=== test/test-xacro-cmake/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(xacro-test)

find_package(xacro REQUIRED)

## manual usage of eval
xacro_add_xacro_file(../include1.xml manual1.xml)
list(APPEND xacro_outputs ${XACRO_OUTPUT_FILE})

xacro_add_xacro_file(../include2.xml manual2.xml OUTPUT MY_OUTPUT_VAR)
list(APPEND xacro_outputs ${MY_OUTPUT_VAR})

add_custom_target(xacro_target ALL DEPENDS ${xacro_outputs})
xacro_install(xacro_target ${xacro_outputs} DESTINATION xml)

## convenience function
xacro_add_files(TARGET xacro test.xacro REMAP bar:=foo foo:=bar INSTALL)

=== debian/changelog ===
ros-crystal-xacro (2.0.1-1bionic) bionic; urgency=high

  * Revert requiring that all xacro commands are prefixed with 'xacro:' namespace
    Although this is deprecated since #79 <https://github.com/ros/xacro/issues/79>,
    the corresponding deprecation warning wasn't actually issued.
    Thus, we will accept non-prefixed xacro tags until F-turtle.
  * Install to both, bin/xacro and lib/xacro/xacro
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 05 Oct 2019 22:00:00 -0000

ros-crystal-xacro (2.0.0-1bionic) bionic; urgency=high

  * PEP8 cleanup
    - code simplifications
    - avoid empty except
    - sort imports
    - format line breaks
  * Code cleanup
    - Removed deprecated options --legacy, --inorder, --check-order, --includes
    - Require all xacro commands to be prefixed with 'xacro:'
    - Added missing copyright notices
    - Removed python2 stuff
  * Adapt Travis config to use colcon
  * Provide ROS2-based replacement for substition args
  * Modified package structure as per ROS2 rules
    - Using ament_cmake
    - Moved source contents from "src/xacro" to "xacro"
    - Modified package.xml and setup.py according to ROS2 requirements
    - Configured completion hook
    - Removed catkin artifacts from cmake extension
  * Contributors: vandanamandlik, Jacob Perron, Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 27 Sep 2019 22:00:00 -0000

ros-crystal-xacro (1.13.4-1bionic) bionic; urgency=high

  * [feature] remove xmlns:xacro from processed file (#207 <https://github.com/ros/xacro/issues/207>)
    - Remove all notions of xmlns:xacro from the resulting document.
    - If the root node defines a xacro:targetNamespace attribute, this will become the global xmlns namespace of the resulting document.
  * [feature] Add len() to allowed python functions (#208 <https://github.com/ros/xacro/issues/208>)
  * [maintanence]
    - --in-order warning: reduce severity level to message
    - fix and cleanup test of cmake extensions
    - adapt run_xacro() to run xacro from PATH
    - simplify import of substition_args
    - remove 'requires' field from setup.py
    - fix Travis config: use new repository key, use xenial/kinetic distro
    - basic README.md
    - fix catkin_lint issue
    - remove duplicate catkin_python_setup() (#206 <https://github.com/ros/xacro/issues/206>)
  * Contributors: Robert Haschke, James Xu, Martin Pecka

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Wed, 25 Sep 2019 22:00:00 -0000

ros-crystal-xacro (1.13.3-1bionic) bionic; urgency=high

  * use INORDER as default in cmake functions
  * remove weird 'None's in error messages
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sat, 13 Oct 2018 22:00:00 -0000

ros-crystal-xacro (1.13.2-1bionic) bionic; urgency=high

  * deprecate --includes option (which is tied to deprecated --legacy processing)
  * moved all option handling to cli.py, including deprecation warnings for options
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sun, 13 May 2018 22:00:00 -0000

ros-crystal-xacro (1.13.1-1bionic) bionic; urgency=high

  * fix parsing of quoted strings in default args for xacro params (#187 <https://github.com/ros/xacro/issues/187>)
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Wed, 02 May 2018 22:00:00 -0000

ros-crystal-xacro (1.13.0-1bionic) bionic; urgency=high

  * make --inorder processing the default
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 30 Mar 2018 22:00:00 -0000

ros-crystal-xacro (1.12.1-1bionic) bionic; urgency=high

  * #183 <https://github.com/ros/xacro/issues/183>: unicode support for python2 and python3
  * #178 <https://github.com/ros/xacro/issues/178>: extend list of allowed python builtins: min, max, round
  * #182 <https://github.com/ros/xacro/issues/182>: suppress xacro warnings when determining dependencies
  * #151 <https://github.com/ros/xacro/issues/151>: fixes for #149 <https://github.com/ros/xacro/issues/149> and #148 <https://github.com/ros/xacro/issues/148>
  * #157 <https://github.com/ros/xacro/issues/157>: fix #156 <https://github.com/ros/xacro/issues/156> access to undefined target_table
  * #150 <https://github.com/ros/xacro/issues/150>: allow True/False literals in python expressions
  * #159 <https://github.com/ros/xacro/issues/159>: load ROS-related packages on demand, thus becoming more independent from ROS
  * #173 <https://github.com/ros/xacro/issues/173>: allow default values for properties
  * #172 <https://github.com/ros/xacro/issues/172>: fix formatting of XacroException
  * #171 <https://github.com/ros/xacro/issues/171>: fix dependency handling (--deps option)
  * #163 <https://github.com/ros/xacro/issues/163>: full python 3 compatibility
  * Contributors: Robert Haschke, Kartik Mohta, Morgan Quigley, Steven Peters

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Tue, 27 Mar 2018 22:00:00 -0000

ros-crystal-xacro (1.12.0-1bionic) bionic; urgency=high



 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Fri, 24 Mar 2017 23:00:00 -0000

ros-crystal-xacro (1.11.2-1bionic) bionic; urgency=high

  * Convert exception to string in a python2/3 compatible way.
  * Use python2/3 independent check for file type.
  * Contributors: Hans Gaiser, Maarten de Vries

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Sun, 26 Feb 2017 23:00:00 -0000

ros-crystal-xacro (1.11.1-1bionic) bionic; urgency=high

  * workaround for xml.dom.minidom issue
  * ensure non-empty error string
  * Contributors: Robert Haschke

 -- Robert Haschke <rhaschke@techfak.uni-bielefeld.de>  Tue, 21 Jun 2016 22:00:00 -0000

ros-crystal-xacro (1.11.0-1bionic) bionic; urgency=high

  * added short option -i as alternative to --inorder
  * refactored main to fix #122, #107
  * added xacro indicator to error message to fix #123


=== debian/control ===
Source: ros-crystal-xacro
Section: misc
Priority: extra
Maintainer: Robert Haschke <rhaschke@techfak.uni-bielefeld.de>
Build-Depends: debhelper (>= 9.0.0), python3-yaml, ros-crystal-ament-cmake, ros-crystal-ament-cmake-pytest, ros-crystal-ament-index-python, ros-crystal-ament-lint-auto, ros-crystal-ros-workspace
Homepage: http://ros.org/wiki/xacro
Standards-Version: 3.9.2

Package: ros-crystal-xacro
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3-yaml, ros-crystal-ament-index-python, ros-crystal-ros-workspace
Description: Xacro (XML Macros) Xacro is an XML macro language.
 With xacro, you can construct shorter and more readable XML files by using macros that expand to larger XML expressions.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/crystal/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/crystal" \
		-DAMENT_PREFIX_PATH="/opt/ros/crystal"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-crystal-xacro//opt/ros/crystal/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/crystal/setup.sh" ]; then . "/opt/ros/crystal/setup.sh"; fi && \
	dh_auto_install
